package apis

import (
	"fmt"

	"github.com/gin-gonic/gin"
	"github.com/go-admin-team/go-admin-core/sdk/api"
	"github.com/go-admin-team/go-admin-core/sdk/pkg/jwtauth/user"
	_ "github.com/go-admin-team/go-admin-core/sdk/pkg/response"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
)

type LineReduceStrategy struct {
	api.Api
}

// GetPage 获取减仓策略列表
// @Summary 获取减仓策略列表
// @Description 获取减仓策略列表
// @Tags 减仓策略
// @Param name query string false "减仓策略名称"
// @Param status query string false "状态 1-启用 2-禁用"
// @Param pageSize query int false "页条数"
// @Param pageIndex query int false "页码"
// @Success 200 {object} response.Response{data=response.Page{list=[]models.LineReduceStrategy}} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-reduce-strategy [get]
// @Security Bearer
func (e LineReduceStrategy) GetPage(c *gin.Context) {
	req := dto.LineReduceStrategyGetPageReq{}
	s := service.LineReduceStrategy{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	p := actions.GetPermissionFromContext(c)
	list := make([]models.LineReduceStrategy, 0)
	var count int64

	err = s.GetPage(&req, p, &list, &count)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取减仓策略失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.PageOK(list, int(count), req.GetPageIndex(), req.GetPageSize(), "查询成功")
}

// Get 获取减仓策略
// @Summary 获取减仓策略
// @Description 获取减仓策略
// @Tags 减仓策略
// @Param id path int false "id"
// @Success 200 {object} response.Response{data=models.LineReduceStrategy} "{"code": 200, "data": [...]}"
// @Router /api/v1/line-reduce-strategy/{id} [get]
// @Security Bearer
func (e LineReduceStrategy) Get(c *gin.Context) {
	req := dto.LineReduceStrategyGetReq{}
	s := service.LineReduceStrategy{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}
	var object models.LineReduceStrategy

	p := actions.GetPermissionFromContext(c)
	err = s.Get(&req, p, &object)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("获取减仓策略失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(object, "查询成功")
}

// Insert 创建减仓策略
// @Summary 创建减仓策略
// @Description 创建减仓策略
// @Tags 减仓策略
// @Accept application/json
// @Product application/json
// @Param data body dto.LineReduceStrategyInsertReq true "data"
// @Success 200 {object} response.Response	"{"code": 200, "message": "添加成功"}"
// @Router /api/v1/line-reduce-strategy [post]
// @Security Bearer
func (e LineReduceStrategy) Insert(c *gin.Context) {
	req := dto.LineReduceStrategyInsertReq{}
	s := service.LineReduceStrategy{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	if err := req.Valid(); err != nil {
		e.Error(500, err, "")
		return
	}

	// 设置创建人
	req.SetCreateBy(user.GetUserId(c))

	err = s.Insert(&req)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("创建减仓策略失败，\r\n失败信息 %s", err.Error()))
		return
	}

	e.OK(req.GetId(), "创建成功")
}

// Update 修改减仓策略
// @Summary 修改减仓策略
// @Description 修改减仓策略
// @Tags 减仓策略
// @Accept application/json
// @Product application/json
// @Param id path int true "id"
// @Param data body dto.LineReduceStrategyUpdateReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "修改成功"}"
// @Router /api/v1/line-reduce-strategy/{id} [put]
// @Security Bearer
func (e LineReduceStrategy) Update(c *gin.Context) {
	req := dto.LineReduceStrategyUpdateReq{}
	s := service.LineReduceStrategy{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	if err := req.Valid(); err != nil {
		e.Error(500, err, "")
		return
	}

	req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Update(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("修改减仓策略失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "修改成功")
}

// Delete 删除减仓策略
// @Summary 删除减仓策略
// @Description 删除减仓策略
// @Tags 减仓策略
// @Param data body dto.LineReduceStrategyDeleteReq true "body"
// @Success 200 {object} response.Response	"{"code": 200, "message": "删除成功"}"
// @Router /api/v1/line-reduce-strategy [delete]
// @Security Bearer
func (e LineReduceStrategy) Delete(c *gin.Context) {
	s := service.LineReduceStrategy{}
	req := dto.LineReduceStrategyDeleteReq{}
	err := e.MakeContext(c).
		MakeOrm().
		Bind(&req).
		MakeService(&s.Service).
		Errors
	if err != nil {
		e.Logger.Error(err)
		e.Error(500, err, err.Error())
		return
	}

	// req.SetUpdateBy(user.GetUserId(c))
	p := actions.GetPermissionFromContext(c)

	err = s.Remove(&req, p)
	if err != nil {
		e.Error(500, err, fmt.Sprintf("删除减仓策略失败，\r\n失败信息 %s", err.Error()))
		return
	}
	e.OK(req.GetId(), "删除成功")
}
